<!--
/*
 *  Copyright 2012 by Texas Instruments Incorporated .
 *  
 */
-->

<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>Linux Utils Application Programming Interface (API): sdma.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<table width="100%">
<tr>
  <td bgcolor="black" width="1"><a href="http://www.ti.com"><img border="0" src="tilogo.gif" /></a></td>
  <td bgcolor="red"><img src="titagline.gif" /></td>
</tr>
</table>
<!-- Generated by Doxygen 1.7.2 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'Search');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li id="searchli">
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath">
    <ul>
      <li><a class="el" href="dir_46b89352121e85f687ad94af5a42b013.html">packages</a>      </li>
      <li><a class="el" href="dir_dbdfbfe4e1be114d6b897afedfbff330.html">ti</a>      </li>
      <li><a class="el" href="dir_964ef0e4710265d31c86c3d996641bc2.html">sdo</a>      </li>
      <li><a class="el" href="dir_bc87c15b970aa649e4a4941daccc7a87.html">linuxutils</a>      </li>
      <li><a class="el" href="dir_4ef5f955fdd0025e1aca12992102054a.html">sdma</a>      </li>
      <li><a class="el" href="dir_043b8c04d31b294e253b00e8eeae9ef0.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#nested-classes">Data Structures</a> &#124;
<a href="#define-members">Defines</a> &#124;
<a href="#typedef-members">Typedefs</a> &#124;
<a href="#enum-members">Enumerations</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<h1>sdma.h File Reference</h1>  </div>
</div>
<div class="contents">
<hr/><a name="_details"></a><h2>Detailed Description</h2>
<p>Describes the interface to the SDMA manager. </p>
<p>The sdma user interface library wraps file system calls to an associated kernel module (sdmak.ko), which needs to be loaded in order for calls to to this library to succeed.</p>
<p>To install sdmak.ko, enter % insmod sdmak.ko on a Linux command line.</p>
<p>SDMA channels are allocated (requested) from within the sdmak kernel driver through the <a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga61ad0de72b29de1788eec637c1930275" title="Returns available logical channels.">SDMA_getChannels()</a> API. This request is granted by way of the kernel's request_dma() functionality (omap_request_dma() for the OMAP35x), so it will work in conjuntion with independent kernel DMA usage without conflict or custom kernel configuration. The granted channel's registers are memory-mapped into the calling user address space to allow the application to directly access the DMA registers for that channel.</p>
<p>A DMA callback ISR is registered within the stock kernel DMA manager, and this ISR is used for completion notification (although it could be customized to handle any DMA-generated interrupt). Notification to the user interface layer is accomplished by way of a user state structure whose address is passed to the sdmak kernel driver and which is directly written upon completion. Atomic hand-shaking allows the kernel driver to know if the application is going to wait for the completion by way of the corresponding sdmak ioctl(), as opposed to just checking the user state structure, and post a channel-specific mutex only when needed (otherwise just the completion flag in the state structure is set).</p>
<p>Since the SDMA interface library doesn't use the GT tracing facility, there is one configuration option available for the SDMA module to control whether the debug or release interface library is used for building the application. This config parameter is named 'debug' and is of type bool, and the default value is 'false'.</p>
<p>The following line is an example of enabling usage of the debug interface library: var sdma = xdc.useModule('ti.sdo.linuxutils.sdma.SDMA'); sdma.debug = true; This will enable "SDMA Debug" statements to be printed to stdout. </p>

<p><a href="sdma_8h_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="nested-classes"></a>
Data Structures</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_s_d_m_a__transfer_state.html">SDMA_transferState</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">State structure shared between SDMAK and SDMA user layers.  <a href="struct_s_d_m_a__transfer_state.html#_details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">union &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="union_s_d_m_a__request_dma_params.html">SDMA_requestDmaParams</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">SDMAK ioctl input/output parameters.  <a href="union_s_d_m_a__request_dma_params.html#_details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_s_d_m_a___channel_descriptor.html">SDMA_ChannelDescriptor</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Descriptor for a channel granted with a SDMA_IOCREQUESTDMA ioctl().  <a href="struct_s_d_m_a___channel_descriptor.html#_details">More...</a><br/></td></tr>
<tr><td colspan="2"><h2><a name="define-members"></a>
Defines</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga5a56502b7267c0d282482430b31bafbf">SDMA_VERSION</a>&#160;&#160;&#160;0x01010000U</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga575ba4b089ce068f316ea8f26329731e">SDMA_IOCMAGIC</a>&#160;&#160;&#160;0x0000fb00</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">SDMAK ioctl() commands.  <a href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga575ba4b089ce068f316ea8f26329731e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga871606b17c30573afd86ce0eb8aed793">SDMA_IOCCMDMASK</a>&#160;&#160;&#160;0x000000ff</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga3e69a60f4fb4165cf6e9bae183d76e18">SDMA_IOCREQUESTDMA</a>&#160;&#160;&#160;1</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#gaf61056646c5f1f470ad48f25f8bec891">SDMA_IOCRELEASEDMA</a>&#160;&#160;&#160;2</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga0233858df32d487eccc7222f177a4535">SDMA_IOCWAITFORCOMPLETION</a>&#160;&#160;&#160;3</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga12b43daa7600cb5eb684874e5a35cb14">SDMA_IOCGETVERSION</a>&#160;&#160;&#160;4</td></tr>
<tr><td colspan="2"><h2><a name="typedef-members"></a>
Typedefs</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef struct <br class="typebreak"/>
<a class="el" href="struct_s_d_m_a___channel_descriptor.html">SDMA_ChannelDescriptor</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#gac90fcbb51fb47d76978a2a43959ea1dc">SDMA_ChannelDescriptor</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Descriptor for a channel granted with a SDMA_IOCREQUESTDMA ioctl().  <a href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#gac90fcbb51fb47d76978a2a43959ea1dc"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef enum <a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga0320eede22af77d23066c79b98f83d86">SDMA_Status</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga4b4405f362573bbae71e5808df1cbe99">SDMA_Status</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Status codes for SDMA API return values.  <a href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga4b4405f362573bbae71e5808df1cbe99"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="enum-members"></a>
Enumerations</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga0320eede22af77d23066c79b98f83d86">SDMA_Status</a> { <br/>
&#160;&#160;<a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#gga0320eede22af77d23066c79b98f83d86aaedf16bd0ba00df842dbc025dd670355">SDMA_OK</a> =  0, 
<br/>
&#160;&#160;<a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#gga0320eede22af77d23066c79b98f83d86aed3a0eaeb1a46c9ab4bf9720767675c5">SDMA_EFAIL</a>, 
<br/>
&#160;&#160;<a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#gga0320eede22af77d23066c79b98f83d86ac5fd05a19b35afdb5a7d73c83077dc3a">SDMA_ENOCHANNEL</a>, 
<br/>
&#160;&#160;<a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#gga0320eede22af77d23066c79b98f83d86a5149eca0e66ee63328729ef1fcd78fdd">SDMA_ENOINIT</a>
<br/>
 }</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight"><p>Status codes for SDMA API return values. </p>
 <a href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga0320eede22af77d23066c79b98f83d86">More...</a><br/></td></tr>
<tr><td colspan="2"><h2><a name="func-members"></a>
Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga2f696c8f6e535ff8b8a50946aa801bc2">SDMA_init</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">SDMA initialization API.  <a href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga2f696c8f6e535ff8b8a50946aa801bc2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga8dff87d79d68c1e9a3eb54ca4133ec7c">SDMA_exit</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">SDMA finalization API.  <a href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga8dff87d79d68c1e9a3eb54ca4133ec7c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga0320eede22af77d23066c79b98f83d86">SDMA_Status</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga61ad0de72b29de1788eec637c1930275">SDMA_getChannels</a> (int numChannels, <a class="el" href="struct_s_d_m_a___channel_descriptor.html">SDMA_ChannelDescriptor</a> chanArray[])</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns available logical channels.  <a href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga61ad0de72b29de1788eec637c1930275"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga0320eede22af77d23066c79b98f83d86">SDMA_Status</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga81c0e872ec8e43abecc801f5da40c6e6">SDMA_freeChannels</a> (int numChannels, <a class="el" href="struct_s_d_m_a___channel_descriptor.html">SDMA_ChannelDescriptor</a> chanArray[])</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Frees previously requested logical channels.  <a href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga81c0e872ec8e43abecc801f5da40c6e6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga0320eede22af77d23066c79b98f83d86">SDMA_Status</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga3e11eddf1b871b7499a104acefcfb328">SDMA_wait</a> (<a class="el" href="struct_s_d_m_a___channel_descriptor.html">SDMA_ChannelDescriptor</a> *channel)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Waits for the transfer corresponding to this descriptor to complete.  <a href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga3e11eddf1b871b7499a104acefcfb328"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga0320eede22af77d23066c79b98f83d86">SDMA_Status</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga04c8ced481b3043a8347a9df4fe3a715">SDMA_check</a> (<a class="el" href="struct_s_d_m_a___channel_descriptor.html">SDMA_ChannelDescriptor</a> *channel, int *pcompleted)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Checks the status of the transfer corresponding to this descriptor and returns it in the *pcompleted field.  <a href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga04c8ced481b3043a8347a9df4fe3a715"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga8565a8d49e15ea9769f1a9c698ed229c">SDMA_getVersion</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Retrieve version from SDMA driver.  <a href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga8565a8d49e15ea9769f1a9c698ed229c"></a><br/></td></tr>
</table>
</div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Data Structures</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Defines</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<hr size="1" /><small>
Copyright  2012, Texas Instruments Incorporated</small>
</body>
</html>
<!--
/*
 * @(#) linuxutils_3_23_00_01; 1, 0, 0,1; 5-30-2012 11:51:36; /db/atree/library/trees/linuxutils/linuxutils-l01/src/ xlibrary

 */
-->

